/* MailTweak internal component - Copyright (C) 2007 Rod Whiteley - Licensed under the Open Software License version 3.0 - Source at http://journal.mozdev.org/mailtweak.html */
MailTweak = {
init: function () {
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.")
if (pref.getBoolPref("wordcount"))
addEventListener("load", function () {MailTweak.WordCount.load()}, false)
if (pref.getBoolPref("permapen"))
addEventListener("load", function () {MailTweak.PermaPen.load()}, false)},PermaPen: {
key: "",face: "",size: 0,color: "",ground: "",styleSet: [],styleNot: [],_active: false,activate: function (ok) {
if (ok === true || ok === false) this._active = ok
else this._active = !this._active
document.getElementById("ColorButtons").style.borderLeftColor = this._active? this.color : "transparent"},keyPress: function (event) {
if (!IsHTMLEditor()) return
if (event.keyCode == event["DOM_VK_" + this.key]) {
this.activate()
return}
if (!this._active) return
with (GetCurrentEditor()) {
// dump(">> " + here + "\n")
if (this.face) setInlineProperty(this._font, "face", this.face)
if (this.size) setInlineProperty(this._font, "size", this.size)
if (this.color) setInlineProperty(this._font, "color", this.color)
setInlineProperty(this._font, "style", this._style)}
for each (var cmd in this.styleSet) {
cmd = "cmd_" + cmd
var on = top.document.getElementById(cmd).getAttribute("state") == "true"
if (!on) doStyleUICommand(cmd)}
for each (var cmd in this.styleNot) {
cmd = "cmd_" + cmd
var on = top.document.getElementById(cmd).getAttribute("state") == "true"
if (on) doStyleUICommand(cmd)}},load: function () {
this._active = false
var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extension.mailtweak.permapen.")
this.key = pref.getCharPref("key")
this.face = pref.getCharPref("face")
this.size = pref.getIntPref("size")
this.color = pref.getCharPref("color")
this.ground = pref.getCharPref("ground")
this[pref.getBoolPref("bold")? "styleSet":"styleNot"].push("bold")
this[pref.getBoolPref("italic")? "styleSet":"styleNot"].push("italic")
this[pref.getBoolPref("underline")? "styleSet":"styleNot"].push("underline")
with (document.getElementById("ColorButtons").style)
borderStyle = "solid",borderWidth = "0 0 0 2px",borderLeftColor = "transparent"
if (!gAtomService) GetAtomService()
this._font = gAtomService.getAtom("font")
var rgb = function (c) {
return "rgb("
+ Number("0x" + c.substr(1, 2)) + ", "
+ Number("0x" + c.substr(3, 2)) + ", "
+ Number("0x" + c.substr(5, 2)) + ")"}
// "color: " + rgb(this.color) + "; "
this._style = "background-color: " + rgb(this.ground) + ";"
addEventListener("keypress",function (event) {MailTweak.PermaPen.keyPress(event)},true)}},WordCount: {
oneWord: "",manyWords: "",oneChar: "",manyChars: "",load: function () {
with (document.getElementById("mailtweak-data"))
this.oneWord = getAttribute("one"),this.manyWords = getAttribute("many"),this.oneChar = getAttribute("onechar"),this.manyChars = getAttribute("manychar")
this._status = document.getElementById("statusText")
countWords = function () {
var sel = null
with (document.getElementById("content-frame"))
try {sel = getEditor(contentWindow).selection} catch (ex) {}
if (sel) sel.QueryInterface(Components.interfaces.nsISelectionPrivate).addSelectionListener(MailTweak.WordCount)}
with (document.getElementById("selectEditMenuItems"))
setAttribute("oncommandupdate",getAttribute("oncommandupdate") + ";countWords()")},notifySelectionChanged: function (doc, sel, why) {
var txt = sel.toString().replace(/[\r\n]/g, "")
var c = txt.length
var wds = txt.match(/(^|\s+)\S/g)
var w = wds? wds.length : 0
if (document.getElementById("status-bar").hidden)
goToggleToolbar("status-bar", "menu_showTaskbar")
this._status.label = c == 0 ? "" :
(w == 1 ? this.oneWord : this.manyWords.replace("#", w))
+ (c == 1 ? this.oneChar : this.manyChars.replace("#", c))}}}
MailTweak.init()